Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::FMVoices Class Reference

STK singing FM synthesis instrument. More...

`#include <FMVoices.h>`

Inheritance diagram for stk::FMVoices:

List of all members.

## Public Member Functions
| FMVoices (void)
| Class constructor.
| ~FMVoices (void)
| Class destructor.
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude.
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK singing FM synthesis instrument.

This class implements 3 carriers and a common modulator, also referred to as algorithm 6 of the TX81Z.

        Algorithm 6 is :
                            /->1 -\
                         4-|-->2 - +-> Out
                            \->3 -/

Control Change Numbers:

- Vowel = 2
- Spectral Tilt = 4
- LFO Speed = 11
- LFO Depth = 1
- ADSR 2 & 4 Target = 128

The basic Chowning/Stanford FM patent expired in 1995, but there exist follow-on patents, mostly assigned to Yamaha. If you are of the type who should worry about this (making money) worry away.

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Constructor & Destructor Documentation

stk::FMVoices::FMVoices | ( | void |  | ) |

Class constructor.

An StkError will be thrown if the rawwave path is incorrectly set.

## Member Function Documentation

StkFrames & stk::FMVoices::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::FM.

    00107 {
    00108   unsigned int nChannels = lastFrame_.channels();
    00109 #if defined(_STK_DEBUG_)
    00110   if ( channel > frames.channels() - nChannels ) {
    00111     oStream_ << "FMVoices::tick(): channel and StkFrames arguments are incompatible!";
    00112     handleError( StkError::FUNCTION_ARGUMENT );
    00113   }
    00114 #endif
    00115
    00116   StkFloat *samples = &frames[channel];
    00117   unsigned int j, hop = frames.channels() - nChannels;
    00118   if ( nChannels == 1 ) {
    00119     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00120       *samples++ = tick();
    00121   }
    00122   else {
    00123     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00124       *samples++ = tick();
    00125       for ( j=1; j<nChannels; j++ )
    00126         *samples++ = lastFrame_[j];
    00127     }
    00128   }
    00129
    00130   return frames;
    00131 }

The documentation for this class was generated from the following file:

- FMVoices.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.